#include <memory.h>
#include "../curses.h"
#include "../gdbm-local.h"
#include "../struktury_dbm.h"
#include "../lib_dbm.h"

#define HORN 4

void trideni_vsemestru(DBM * dbm_ptr)
{
    struct zaznam nacteno;
    struct dbm_info informace;
    WINDOW *pad;
    datum klic;
    datum data;
    wint_t klavesa;
    int i;
    int ukazatel;

    informace = zjisti_informace(dbm_ptr);

    pad = newpad(informace.poc_zaznamu + SEMESTRU * 3, COLS);
    erase();
    printw("Čekejte ...");
    refresh();

    for (i = 0; i <= SEMESTRU; i++) {
	if (!informace.predmetu[i][1])
	    continue;
	wattron(pad, COLOR_PAIR(3));
	if (!i)
	    wprintw(pad, "\nNEUDĚLÁNO\n");
	else
	    wprintw(pad, "\nSEMESTR   %2i\n", i);
	wprintw(pad, "%-*s\n", COLS - 1, "-----------------------------");
	wattroff(pad, COLOR_PAIR(3));

	for (klic = dbm_firstkey(dbm_ptr); klic.dptr;
	     klic = dbm_nextkey(dbm_ptr)) {
	    data = dbm_fetch(dbm_ptr, klic);
	    memcpy(&nacteno, data.dptr, data.dsize);

	    if (nacteno.vsemestru == i) {
		if (!nacteno.vsemestru)
		    wattron(pad, A_BOLD);
		wprintw8(pad, L"%4ls %-40ls %6i %6i ",
			 nacteno.kod, nacteno.nazev,
			 nacteno.semestr, nacteno.kreditu);
		if (nacteno.znamka)
		    wprintw(pad, "%6i", nacteno.znamka);
		else
		    wprintw8(pad, L"%6s", "-");
		waddch(pad, '\n');
		if (!nacteno.vsemestru)
		    wattroff(pad, A_BOLD);
	    }
	}
    }

    erase();
    mvprintw(0, 0, "BACKSPACE nebo F10 = konec;");
    mvprintw(1, 0, "%i záznamů.\n", informace.poc_zaznamu);
    mvprintw8(2, 0, L"%4s %-40s %6s %6s %6s", "kód:", "Název",
	      "sem.", "kredit", "známka");
    refresh();


    ukazatel = 0;
    i = informace.poc_zaznamu + SEMESTRU * 3 - (LINES - 1 - HORN);
    do {
	prefresh(pad, ukazatel, 0, HORN, 0, LINES - 1, COLS - 1);
	(void) get_wch(&klavesa);
	switch (klavesa) {
	case L' ':
	case KEY_DOWN:
	    if (ukazatel < i - 1)
		ukazatel++;
	    break;
	case KEY_UP:
	    if (ukazatel > 0)
		ukazatel--;
	    break;
	default:
	    break;
	}
    }
    while (klavesa != KEY_BACKSPACE && klavesa != KEY_F(10));

    delwin(pad);
}
